svn commit: r351393 - head/sbin/ping/tests
Alan Somers
asomers at FreeBSD.org
Thu Aug 22 15:00:37 UTC 2019
Author: asomers
Date: Thu Aug 22 15:00:36 2019
New Revision: 351393
URL: https://svnweb.freebsd.org/changeset/base/351393
Log:
ping: add a basic functional test
Submitted by: Ján Sučan <sucanjan at gmail.com>
MFC after: 2 weeks
Sponsored by: Google, inc. (Google Summer of Code 2019)
Differential Revision: https://reviews.freebsd.org/D21289
Added:
head/sbin/ping/tests/ping_c1_s56_t1.out (contents, props changed)
head/sbin/ping/tests/ping_test.sh (contents, props changed)
Modified:
head/sbin/ping/tests/Makefile
Modified: head/sbin/ping/tests/Makefile
==============================================================================
--- head/sbin/ping/tests/Makefile Thu Aug 22 12:09:34 2019 (r351392)
+++ head/sbin/ping/tests/Makefile Thu Aug 22 15:00:36 2019 (r351393)
@@ -5,4 +5,9 @@ WARNS?= 6
ATF_TESTS_C+= in_cksum_test
SRCS.in_cksum_test= in_cksum_test.c ../utils.c
+PACKAGE= tests
+
+ATF_TESTS_SH+= ping_test
+${PACKAGE}FILES+= ping_c1_s56_t1.out
+
.include <bsd.test.mk>
Added: head/sbin/ping/tests/ping_c1_s56_t1.out
==============================================================================
--- /dev/null 00:00:00 1970 (empty, because file is newly added)
+++ head/sbin/ping/tests/ping_c1_s56_t1.out Thu Aug 22 15:00:36 2019 (r351393)
@@ -0,0 +1,6 @@
+PING localhost: 56 data bytes
+64 bytes from localhost: icmp_seq=0 ttl= time= ms
+
+--- localhost ping statistics ---
+1 packets transmitted, 1 packets received, 0.0% packet loss
+round-trip min/avg/max/stddev = /// ms
Added: head/sbin/ping/tests/ping_test.sh
==============================================================================
--- /dev/null 00:00:00 1970 (empty, because file is newly added)
+++ head/sbin/ping/tests/ping_test.sh Thu Aug 22 15:00:36 2019 (r351393)
@@ -0,0 +1,55 @@
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (C) 2019 Jan Sucan <jansucan at FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+
+atf_test_case ping_c1_s56_t1
+ping_c1_s56_t1_head() {
+ atf_set "descr" "Stop after receiving 1 ECHO_RESPONSE packet"
+}
+ping_c1_s56_t1_body() {
+ if ! getaddrinfo -f inet localhost 1>/dev/null 2>&1; then
+ atf_skip "IPv4 is not configured"
+ fi
+ atf_check -s exit:0 -o save:std.out -e empty \
+ ping -c 1 -s 56 -t 1 localhost
+ check_ping_statistics std.out $(atf_get_srcdir)/ping_c1_s56_t1.out
+}
+
+atf_init_test_cases() {
+ atf_add_test_case ping_c1_s56_t1
+}
+
+check_ping_statistics() {
+ sed -e 's/0.[0-9]\{3\}//g' \
+ -e 's/[1-9][0-9]*.[0-9]\{3\}//g' \
+ -e 's/localhost ([0-9]\{1,3\}\(\.[0-9]\{1,3\}\)\{1,3\})/localhost/' \
+ -e 's/from [0-9]\{1,3\}\(\.[0-9]\{1,3\}\)\{1,3\}/from/' \
+ -e 's/ttl=[0-9][0-9]*/ttl=/' \
+ "$1" >"$1".filtered
+ atf_check -s exit:0 diff -u "$1".filtered "$2"
+}
More information about the svn-src-head
mailing list